// lorenzDlg.cpp : implementation file
//

#include "stdafx.h"
#include "lorenz.h"
#include "lorenzDlg.h"
#include "math.h"
#include "dverk.h"

#include "dverk.cpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// my vars:
  CDC *pDCxy, *pDCxz, *pDCyz;
  CDC *pDCxt, *pDCyt, *pDCzt;
  RECT rectxyEx, rectxyIn;
  RECT rectxzEx, rectxzIn;
  RECT rectyzEx, rectyzIn;
  RECT rectxtEx, rectxtIn;
  RECT rectytEx, rectytIn;
  RECT rectztEx, rectztIn;
  double xMin, xMax, yMin, yMax, zMin, zMax, tMin, tMax;
  double sigma, beta, gamma;
  int M;
// for dverk:
  const int mNDIM = 3;
  int mIND, count;
  double mERRMAX;
  double mYYY [mNDIM];
  double mYFLOOR [mNDIM];
  double mDWORK [9*mNDIM];
  DVERKCTRL dvc;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLorenzDlg dialog

CLorenzDlg::CLorenzDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLorenzDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLorenzDlg)
	m_szOutFileName = _TEXT("result//output.dat");
	m_szInfo = _TEXT("info");
	m_Omega = 17.1;
	m_tStep = 0.01;
	m_tMax = 100.0;
  m_sigma = 10.0;
  m_gamma = 23; 
  m_beta = 8.0/3.0;
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLorenzDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLorenzDlg)
// windows:
  DDX_Control(pDX, IDC_GR_xy, m_grxy);
  DDX_Control(pDX, IDC_GR_xz, m_grxz);
  DDX_Control(pDX, IDC_GR_yz, m_gryz);
  DDX_Control(pDX, IDC_GR_xt, m_grxt);
  DDX_Control(pDX, IDC_GR_yt, m_gryt);
  DDX_Control(pDX, IDC_GR_zt, m_grzt);
// files:
	DDX_Text(pDX, IDC_ED_FILE, m_szOutFileName);
// data:
	DDX_Text(pDX, IDC_ED_Omega, m_Omega);
	DDX_Text(pDX, IDC_ED_Step, m_tStep);
	DDX_Text(pDX, IDC_ED_tMax, m_tMax);
	DDX_Text(pDX, IDC_ED_sigma, m_sigma);
	DDX_Text(pDX, IDC_ED_gamma, m_gamma);
	DDX_Text(pDX, IDC_ED_beta, m_beta);
	DDX_Text(pDX, IDC_EDIT_INFO, m_szInfo);
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLorenzDlg, CDialog)
	//{{AFX_MSG_MAP(CLorenzDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_Run, OnBUTTONRun)
	ON_BN_CLICKED(IDC_BUTTON_About, OnBUTTONAbout)
	//}}AFX_MSG_MAP
	ON_BN_DOUBLECLICKED(ID_THREAD, &CLorenzDlg::OnBnDoubleclickedThread)
	ON_BN_CLICKED(ID_THREAD, &CLorenzDlg::OnBnClickedThread)
	ON_BN_SETFOCUS(ID_THREAD, &CLorenzDlg::OnBnSetfocusThread)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLorenzDlg message handlers

BOOL CLorenzDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
  xMax =  32.0;
  xMin = -xMax;
  yMin = -xMax;
  yMax =  xMax;
  zMin =  0.0;
  zMax =  2.0*xMax;
  tMin = 0.0;
  tMax = m_tMax;
    dvc.nErrThumb = 3; //! weights = 1/MAX(ABS(dvc->dErrFloor), ABS(Y(K)))
    dvc.dErrFloor      = 1.0e-6; //!  FLOOR VALUE.
    dvc.dStepMin       = 1.0e-7; //!  HMIN
    dvc.dStepStart     = 0.001;   //!  HSTART
    dvc.dScale         = 100.0;  //!  A MEASURE OF THE SCALE OF THE PROBLEM.
    dvc.dStepMax       = 0.1;   //!  HMAX SPECIFICATION.
    dvc.lMaxFuncCalls  = 1.0e7;  //!  MAXIMUM NUMBER OF FUNCTION EVALUATIONS.
    dvc.nInterrupt1    = 0;      //!  INTERRUPT NUMBER 1 .
    dvc.nInterrupt2    = 0;      //!  INTERRUPT NUMBER 2.
    mERRMAX  = 0.00001;  //  0.000001
    count = 0;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLorenzDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CLorenzDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

inline int xyMoveTo(double x, double y){
  pDCxy->MoveTo(
  rectxyIn.left + int(((x-xMin)/(xMax-xMin))*(rectxyIn.right -rectxyIn.left)),
  rectxyIn.top  + int(((y-yMin)/(yMax-yMin))*(rectxyIn.bottom-rectxyIn.top)));
  return NULL;
}
inline int xyLineTo(double x, double y){
  pDCxy->LineTo(
  rectxyIn.left + int(((x-xMin)/(xMax-xMin))*(rectxyIn.right -rectxyIn.left)),
  rectxyIn.top  + int(((y-yMin)/(yMax-yMin))*(rectxyIn.bottom-rectxyIn.top)));
  return NULL;
}

inline int xzLineTo(double x, double z){
  pDCxz->LineTo(
  rectxzIn.left + int(((x-xMin)/(xMax-xMin))*(rectxzIn.right -rectxzIn.left)),
  rectxzIn.top  + int(((z-zMin)/(zMax-zMin))*(rectxzIn.bottom-rectxzIn.top)));
  return NULL;
}
inline int xzMoveTo(double x, double z){
  pDCxz->MoveTo(
  rectxzIn.left + int(((x-xMin)/(xMax-xMin))*(rectxzIn.right -rectxzIn.left)),
  rectxzIn.top  + int(((z-zMin)/(zMax-zMin))*(rectxzIn.bottom-rectxzIn.top)));
  return NULL;
}

inline int yzMoveTo(double y, double z){
  pDCyz->MoveTo(
  rectyzIn.left + int(((y-yMin)/(yMax-yMin))*(rectyzIn.right -rectyzIn.left)),
  rectyzIn.top  + int(((z-zMin)/(zMax-zMin))*(rectyzIn.bottom-rectyzIn.top)));
  return NULL;
}
inline int yzLineTo(double y, double z){
  pDCyz->LineTo(
  rectyzIn.left + int(((y-yMin)/(yMax-yMin))*(rectyzIn.right -rectyzIn.left)),
  rectyzIn.top  + int(((z-zMin)/(zMax-zMin))*(rectyzIn.bottom-rectyzIn.top)));
  return NULL;
}

inline int xtMoveTo(double t, double x){
  pDCxt->MoveTo(
  rectxtIn.left + int(((t-tMin)/(tMax-tMin))*(rectxtIn.right -rectxtIn.left)),
  rectxtIn.top  + int(((x-xMin)/(xMax-xMin))*(rectxtIn.bottom-rectxtIn.top)));
  return NULL;
}
inline int xtLineTo(double t, double x){
  pDCxt->LineTo(
  rectxtIn.left + int(((t-tMin)/(tMax-tMin))*(rectxtIn.right -rectxtIn.left)),
  rectxtIn.top  + int(((x-xMin)/(xMax-xMin))*(rectxtIn.bottom-rectxtIn.top)));
  return NULL;
}

inline int ytMoveTo(double t, double y){
  pDCyt->MoveTo(
  rectytIn.left + int(((t-tMin)/(tMax-tMin))*(rectytIn.right -rectytIn.left)),
  rectytIn.top  + int(((y-yMin)/(yMax-yMin))*(rectytIn.bottom-rectytIn.top)));
  return NULL;
}
inline int ytLineTo(double t, double y){
  pDCyt->LineTo(
  rectytIn.left + int(((t-tMin)/(tMax-tMin))*(rectytIn.right -rectytIn.left)),
  rectytIn.top  + int(((y-yMin)/(yMax-yMin))*(rectytIn.bottom-rectytIn.top)));
  return NULL;
}

inline int ztMoveTo(double t, double z){
  pDCzt->MoveTo(
  rectztIn.left + int(((t-tMin)/(tMax-tMin))*(rectztIn.right -rectztIn.left)),
  rectztIn.top  + int(((z-zMin)/(zMax-zMin))*(rectztIn.bottom-rectztIn.top)));
  return NULL;
}
inline int ztLineTo(double t, double z){
  pDCzt->LineTo(
  rectztIn.left + int(((t-tMin)/(tMax-tMin))*(rectztIn.right -rectztIn.left)),
  rectztIn.top  + int(((z-zMin)/(zMax-zMin))*(rectztIn.bottom-rectztIn.top)));
  return NULL;
}

int CLorenzDlg::prepdata(){
  sigma = m_sigma;
  beta = m_beta;
  gamma = m_gamma;
  return FALSE;
}

int FCN(int N, double t, double* Y, double* D)
{
  static double x, y, z;
  x = Y[0];
  y = Y[1];
  z = Y[2];
  D[0] = -sigma*(x-y);
  D[1] =  gamma*x - y - x*z;
  D[2] = -beta*z + x*y;
  count++;
  return TRUE;
}

void CLorenzDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
    double x, y, z, t, t1, t2;
    int m, n, nErr;
		CDialog::OnPaint();
		pDCxy = m_grxy.GetDC();
		pDCxz = m_grxz.GetDC();
		pDCyz = m_gryz.GetDC();
		pDCxt = m_grxt.GetDC();
		pDCyt = m_gryt.GetDC();
		pDCzt = m_grzt.GetDC();
		m_grxy.GetClientRect(&rectxyEx);
		m_grxz.GetClientRect(&rectxzEx);
		m_gryz.GetClientRect(&rectyzEx);
		m_grxt.GetClientRect(&rectxtEx);
		m_gryt.GetClientRect(&rectytEx);
		m_grzt.GetClientRect(&rectztEx);
		CBrush BrushEx, BrushIn;
		BrushEx.CreateSolidBrush(RGB(200, 150, 100));
		BrushIn.CreateSolidBrush(RGB(100, 150, 200));
		pDCxy->FillRect(&rectxyEx, &BrushEx);
		pDCxz->FillRect(&rectxzEx, &BrushEx);
		pDCyz->FillRect(&rectyzEx, &BrushEx);
		pDCxt->FillRect(&rectxtEx, &BrushEx);
		pDCyt->FillRect(&rectytEx, &BrushEx);
		pDCzt->FillRect(&rectztEx, &BrushEx);
		rectxyIn.left   = rectxyEx.left+5; 
		rectxyIn.top    = rectxyEx.top+5; 
		rectxyIn.right  = rectxyEx.right-5; 
		rectxyIn.bottom = rectxyEx.bottom-5; 
		rectxzIn.left   = rectxzEx.left+5; 
		rectxzIn.top    = rectxzEx.top+5; 
		rectxzIn.right  = rectxzEx.right-5; 
		rectxzIn.bottom = rectxzEx.bottom-5; 
		rectyzIn.left   = rectyzEx.left+5; 
		rectyzIn.top    = rectyzEx.top+5; 
		rectyzIn.right  = rectyzEx.right-5; 
		rectyzIn.bottom = rectyzEx.bottom-5; 
		rectxtIn.left   = rectxtEx.left+5; 
		rectxtIn.top    = rectxtEx.top+2; 
		rectxtIn.right  = rectxtEx.right-5; 
		rectxtIn.bottom = rectxtEx.bottom-2; 
		rectytIn.left   = rectytEx.left+5; 
		rectytIn.top    = rectytEx.top+2; 
		rectytIn.right  = rectytEx.right-5; 
		rectytIn.bottom = rectytEx.bottom-2; 
		rectztIn.left   = rectztEx.left+5; 
		rectztIn.top    = rectztEx.top+2; 
		rectztIn.right  = rectztEx.right-5; 
		rectztIn.bottom = rectztEx.bottom-2; 
		pDCxy->FillRect(&rectxyIn, &BrushIn);
		pDCxz->FillRect(&rectxzIn, &BrushIn);
		pDCyz->FillRect(&rectyzIn, &BrushIn);
		pDCxt->FillRect(&rectxtIn, &BrushIn);
		pDCyt->FillRect(&rectxtIn, &BrushIn);
 		pDCzt->FillRect(&rectytIn, &BrushIn);
    FILE_NOT_FOUND:
		FILE * fOut = fopen(m_szOutFileName, "w");
		if(!fOut){
			CString str;
			str.Format("File %s Can't be open", m_szOutFileName);
			MessageBox(str, "Lorenz Error", MB_OK|MB_ICONERROR);
			CFileDialog dlg(TRUE, "dat", m_szOutFileName, OFN_NOREADONLYRETURN|OFN_HIDEREADONLY, "DAT files (*.dat)|*.dat|All files (*.*)|*||");
      if (dlg.DoModal()==TRUE){
				m_szOutFileName = dlg.GetPathName();	
				UpdateData(false);
			}
			goto FILE_NOT_FOUND;
		}
    x = (500+rand()%1000)*0.01;
    y = (500+rand()%1000)*0.003;
    z = (500+rand()%1000)*0.003;
    t = 0.0;
    M = int(m_tMax / m_tStep + 0.000001);
    prepdata();
    xyMoveTo(x, y);  
    xzMoveTo(x, z);
    yzMoveTo(y, z);
    xtMoveTo(t, x);  
    ytMoveTo(t, y);
    ztMoveTo(t, z);
    fprintf (fOut, "xMin = %.3f\n", xMin);
    for(m = 0; m<M; m++){
      t = m * m_tStep;
      mYYY[0] = x;  
      mYYY[1] = y;
      mYYY[2] = z;
      t1 = t; 
      t2 = t + m_tStep;
      mIND = 2;
      nErr = dverk(mNDIM, FCN, &t1, mYYY, t2, mERRMAX, &mIND, &dvc, mYFLOOR, mDWORK);
      x = mYYY[0]; 
      y = mYYY[1];
      z = mYYY[2];
      xyLineTo(x, y);
      xzLineTo(x, z);
      yzLineTo(y, z);
      xtLineTo(t, x);
      ytLineTo(t, y);
      ztLineTo(t, z);
    	fprintf (fOut, " m=%5d t=%8.3f I=%8d x=%8.3f y=%8.3f z=%8.3f\n", 
                       m, t, mIND, x, y, z);
    }
    fclose (fOut);
		m_szInfo.Format("%8d", count);
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLorenzDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLorenzDlg::OnBUTTONRun() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	Invalidate();
	UpdateData(true);
}

void CLorenzDlg::OnBUTTONAbout() 
{
	// TODO: Add your control notification handler code here
  MessageBox("Alexey A Bykov, bykv@mail.ru \
  Moscow State University, department of physics", "Very simple MFC project: Lorenz attractor", MB_OK);
}

void CLorenzDlg::OnBnDoubleclickedThread()
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	Invalidate();
	UpdateData(true);
}

void CLorenzDlg::OnBnClickedThread()
{
	// TODO: Add your control notification handler code here
}

void CLorenzDlg::OnBnSetfocusThread()
{
	// TODO: Add your control notification handler code here
}
