
#include "stdafx.h"
#include "proga.h"
#include <process.h>
#include "dverk.h"
#include "progaDlg.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog{
public:
	CAboutDlg();
  // Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
  // Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg():CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

  const int NDIM = 2;
  double z_a, z_fo, z_fq, z_d; 
  int INDwerk;
  double ERRMAX;
  double YYY [NDIM];
  double YFLOOR [NDIM];
  double DWORK [9*NDIM];
  DVERKCTRL dvc;

/////////////////////////////////////////////////////////////////////////////
// CProgaDlg dialog

CProgaDlg::CProgaDlg(CWnd* pParent /*=NULL*/)	: CDialog(CProgaDlg::IDD, pParent)
{
//	HKEY hKey;
//	RegConnectRegistry("Alligator",HKEY_LOCAL_MACHINE,&hKey);
//	RegCreateKey(HKEY_LOCAL_MACHINE,"Yaroslav",&hKey);
	m_szOutFileName = _TEXT("result//output.dat");
	m_Time = 60.0;
	m_Step = 0.01;
	m_Rate = 0.0;
	m_Freqout = 0.67;
	m_Freq = 1.0;
	m_Decrement = 0.5;
	m_Angle = 0.0;
	m_Amplitude = 10.0;
	m_Accuracy = 0.001;
	m_TrackAbs = _TEXT("");
	m_PhaseAbs = _TEXT("");
	m_PhaseAbs2 = _TEXT("x");
	m_RateAbs = _TEXT("");
	m_RateAbs2 = _TEXT("t");
	m_TrackAbs2 = _TEXT("t");
	m_OrdPhase = _TEXT("");
	m_OrdPhase2 = _TEXT("");
	m_OrdRate = _TEXT("");
	m_OrdRate2 = _TEXT("");
	m_OrdTrack = _TEXT("");
	m_OrdTrack2 = _TEXT("");
    dvc.nErrThumb = 3; //! weights = 1/MAX(ABS(dvc->dErrFloor), ABS(Y(K)))
    dvc.dErrFloor      = 1.0e-6; //!  FLOOR VALUE.
    dvc.dStepMin       = 1.0e-7; //!  HMIN
    dvc.dStepStart     = 0.01;   //!  HSTART
    dvc.dScale         = 100.0;  //!  A MEASURE OF THE SCALE OF THE PROBLEM.
    dvc.dStepMax       = 0.1;   //!  HMAX SPECIFICATION.
    dvc.lMaxFuncCalls  = 1.0e6;  //!  MAXIMUM NUMBER OF FUNCTION EVALUATIONS.
    dvc.nInterrupt1    = 0;      //!  INTERRUPT NUMBER 1 .
    dvc.nInterrupt2    = 0;      //!  INTERRUPT NUMBER 2.
    INDwerk = 2;         //  initialize dverk:
    ERRMAX  = 0.0001;  //  0.000001
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CProgaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgaDlg)
	DDX_Control(pDX, IDC_GR_VEL, m_grRate);
	DDX_Control(pDX, IDC_GR_TRACK, m_grTrack);
	DDX_Control(pDX, IDC_GR_PHASE, m_grPhase);
//  DDX_Control(pDX, IDC_GR_xy, m_grxy);
//  DDX_Control(pDX, IDC_GR_xz, m_grxz);
//  DDX_Control(pDX, IDC_GR_yz, m_gryz);
	DDX_Text(pDX, IDC_ED_TIME, m_Time);
	DDX_Text(pDX, IDC_ED_STEP, m_Step);
	DDX_Text(pDX, IDC_ED_RATE, m_Rate);
	DDX_Text(pDX, IDC_ED_FREQOUT, m_Freqout);
	DDX_Text(pDX, IDC_ED_FREQ, m_Freq);
	DDX_Text(pDX, IDC_ED_DECREMENT, m_Decrement);
	DDX_Text(pDX, IDC_ED_ANGLE, m_Angle);
	DDX_Text(pDX, IDC_ED_AMPLITUDE, m_Amplitude);
	DDX_Text(pDX, IDC_ED_ACCURACY, m_Accuracy);
	DDX_Control(pDX, IDC_RADIO_EULER, m_rbEuler);
	DDX_Control(pDX, IDC_RADIO_RUNGE, m_rbRunge);
	DDX_Text(pDX, IDC_ED_TRACKABS, m_TrackAbs);
	DDX_Text(pDX, IDC_ED_PHASEABS, m_PhaseAbs);
	DDX_Text(pDX, IDC_ED_PHASEABS2, m_PhaseAbs2);
	DDX_Text(pDX, IDC_ED_RATEABS, m_RateAbs);
	DDX_Text(pDX, IDC_ED_RATEABS2, m_RateAbs2);
	DDX_Text(pDX, IDC_ED_TRACKABS2, m_TrackAbs2);
	DDX_Text(pDX, IDC_ED_ORDPHASE, m_OrdPhase);
	DDX_Text(pDX, IDC_ED_ORDPHASE2, m_OrdPhase2);
	DDX_Text(pDX, IDC_ED_ORDRATE, m_OrdRate);
	DDX_Text(pDX, IDC_ED_ORDRATE2, m_OrdRate2);
	DDX_Text(pDX, IDC_ED_ORDTRACK, m_OrdTrack);
	DDX_Text(pDX, IDC_ED_ORDTRACK2, m_OrdTrack2);
	DDX_Text(pDX, IDC_ED_FILE, m_szOutFileName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CProgaDlg, CDialog)
	//{{AFX_MSG_MAP(CProgaDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUT_GRAPH, OnButGraph)
	ON_BN_CLICKED(IDC_BUT_FILE, OnButFile)
	ON_BN_CLICKED(IDC_BUT_ABOUT, OnButAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgaDlg message handlers

BOOL CProgaDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL){
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()){
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_bGraph=false;
	m_rbEuler.SetCheck(true);
	m_rbRunge.SetCheck(false);
	
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CProgaDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

int FCN(int N, double t, double* Y, double* DERY)
{
  static double x, y;
  x = Y[0];
  y = Y[1];
  DERY[0] = y;
  DERY[1] = z_a*cos(z_fo*t) - 2*z_d*y - z_fq*z_fq*sin(x);
  return TRUE;
}

void CProgaDlg::OnPaint(){
	if (IsIconic()){
		CPaintDC dc(this); 
		SendMessage(WM_ICONERASEBKGND, (WPARAM)dc.GetSafeHdc(), 0);
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int ix = (rect.Width() - cxIcon + 1) / 2;
		int iy = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(ix, iy, m_hIcon);
		dc.LineTo(300,300);
	}
	else
	{
		CDialog::OnPaint();
    if(!m_bGraph) return;
		m_bGraph = false;
		CDC *pDCPhase, *pDCTrack, *pDCRate;
//    CDC *pDCxy, *pDCxz, *pDCyz; 
		pDCPhase = m_grPhase.GetDC();
		pDCTrack = m_grTrack.GetDC();
		pDCRate = m_grRate.GetDC();
//		pDCxy = m_grxy.GetDC();
//		pDCxz = m_grxz.GetDC();
//		pDCyz = m_gryz.GetDC();
		RECT rectPhase, rectTrack, rectRate;
//		RECT rectxy, rectxz, rectyz;
		m_grPhase.GetClientRect(&rectPhase);
		m_grTrack.GetClientRect(&rectTrack);
		m_grRate.GetClientRect(&rectRate);
//  m_grxy.GetClientRect(&rectxy);
//  m_grxz.GetClientRect(&rectxz);
//  m_gryz.GetClientRect(&rectyz);
		CBrush Brush;
		Brush.CreateSolidBrush(RGB(200, 200, 200));
		pDCPhase->FillRect(&rectPhase, &Brush);
		pDCTrack->FillRect(&rectTrack, &Brush);
		pDCRate->FillRect(&rectRate, &Brush);
//		pDCxy->FillRect(&rectxy, &Brush);
//		pDCxz->FillRect(&rectxz, &Brush);
//		pDCyz->FillRect(&rectyz, &Brush);
		rectPhase.left+=5; rectPhase.right-=5; rectPhase.top+=5; rectPhase.bottom-=5;
		rectTrack.left+=5; rectTrack.right-=5; rectTrack.top+=5; rectTrack.bottom-=5;
		rectRate.left+=5; rectRate.right-=5; rectRate.top+=5; rectRate.bottom-=5;
//		rectxy.left+=5; rectxy.right-=5; rectxy.top+=5; rectxy.bottom-=5;
//		rectxz.left+=5; rectxz.right-=5; rectxz.top+=5; rectxz.bottom-=5;
//		rectyz.left+=5; rectyz.right-=5; rectyz.top+=5; rectyz.bottom-=5;
		double Xmax, Xmin, Ymax, Ymin;
    LABEL_FILE_NOT_FOUND:
		FILE * fOut = fopen(m_szOutFileName, "w");
		if(!fOut){
			CString str;
			str.Format("   %s    .", m_szOutFileName);
			MessageBox(str, "Kolebanie Error", MB_OK|MB_ICONERROR);
			CFileDialog dlg(TRUE, "dat", m_szOutFileName, OFN_NOREADONLYRETURN|OFN_HIDEREADONLY, "DAT files (*.dat)|*.dat|All files (*.*)|*||");
      if (dlg.DoModal()==TRUE){
				m_szOutFileName = dlg.GetPathName();	
				UpdateData(false);
			}
			goto LABEL_FILE_NOT_FOUND;
		}
		CString str;
			double x = m_Angle;
			double y = m_Rate;
//			double k1,q1,k2,q2,k3,q3,k4,q4,dx,dy;
			double t=0;
//			double X,Y;
			Xmax = Xmin = x;
			Ymax = Ymin = y;
      double t1, t2;
      int nErr; 
      INDwerk = 2;
      for(t=0; t<m_Time; t+=m_Step){
        YYY[0] = x; YYY[1] = y;
        t1 = t; t2 = t+m_Step;
        z_a = m_Amplitude; z_fo = m_Freqout; z_d = m_Decrement; z_fq = m_Freq;
  nErr = dverk(NDIM, FCN, &t1, YYY, t2, ERRMAX, &INDwerk, &dvc, YFLOOR, DWORK);
        x = YYY[0]; y = YYY[1];
        if (x>Xmax) Xmax = x;
        if (y>Ymax) Ymax = y;
        if (x<Xmin) Xmin = x;
        if (y<Ymin) Ymin = y;
        if (m_rbRunge.GetCheck()){;}
      }
			x = m_Angle;
			y = m_Rate;
			t=0;
			pDCTrack->MoveTo(
        int((t-0)/m_Time*(rectTrack.right-rectTrack.left)+rectTrack.left),
        int((x-Xmin)/(Xmax-Xmin)*(rectTrack.bottom-rectTrack.top)+rectTrack.top));
			pDCRate->MoveTo(
        int((t-0)/m_Time*(rectTrack.right-rectTrack.left)+rectTrack.left),
        int((y-Ymin)/(Ymax-Ymin)*(rectTrack.bottom-rectTrack.top)+rectTrack.top));
			pDCPhase->MoveTo(
        int((x-Xmin)/(Xmax-Xmin)*(rectTrack.right-rectTrack.left)+rectTrack.left),
        int((y-Ymin)/(Ymax-Ymin)*(rectTrack.bottom-rectTrack.top)+rectTrack.top));
/*
      pDCxy->MoveTo(
        int((x-Xmin)/(Xmax-Xmin)*(rectxy.right-rectxy.left)+rectxy.left),
        int((y-Ymin)/(Ymax-Ymin)*(rectxy.bottom-rectxy.top)+rectxy.top));
			pDCxz->MoveTo(
        int((x-Xmin)/(Xmax-Xmin)*(rectxz.right-rectxz.left)+rectxz.left),
        int((y-Ymin)/(Ymax-Ymin)*(rectxz.bottom-rectxz.top)+rectxz.top));
			pDCyz->MoveTo(
        int((x-Xmin)/(Xmax-Xmin)*(rectyz.right-rectyz.left)+rectyz.left),
        int((y-Ymin)/(Ymax-Ymin)*(rectyz.bottom-rectyz.top)+rectyz.top));
*/
			fprintf (fOut, "The first value of angle was X=%.3f, of velocity - V=%.3f \n",x,y);
      INDwerk = 2;
			for(t=0; t<m_Time; t+=m_Step){
        YYY[0] = x; YYY[1] = y;
        t1 = t; t2 = t+m_Step;
        z_a = m_Amplitude; z_fo = m_Freqout; z_d = m_Decrement; z_fq = m_Freq;
  nErr = dverk(NDIM, FCN, &t1, YYY, t2, ERRMAX, &INDwerk, &dvc, YFLOOR, DWORK);
        x = YYY[0]; y = YYY[1];
				fprintf(fOut,"T3 = %.3f   X3 = %.3f   V3 = %.3f \n",t,x,y);
				pDCTrack->LineTo(
          int((t-0)/m_Time*(rectTrack.right-rectTrack.left)+rectTrack.left),
          int((x-Xmin)/(Xmax-Xmin)*(rectTrack.bottom-rectTrack.top)+rectTrack.top));
				pDCRate->LineTo(
          int((t-0)/m_Time*(rectTrack.right-rectTrack.left)+rectTrack.left),
          int((y-Ymin)/(Ymax-Ymin)*(rectTrack.bottom-rectTrack.top)+rectTrack.top));
				pDCPhase->LineTo(
          int((x-Xmin)/(Xmax-Xmin)*(rectTrack.right-rectTrack.left)+rectTrack.left),
          int((y-Ymin)/(Ymax-Ymin)*(rectTrack.bottom-rectTrack.top)+rectTrack.top));
/*
			pDCxy->LineTo(
        int((x-Xmin)/(Xmax-Xmin)*(rectxy.right-rectxy.left)+rectxy.left),
        int((y-Ymin)/(Ymax-Ymin)*(rectxy.bottom-rectxy.top)+rectxy.top));
			pDCxz->LineTo(
        int((x-Xmin)/(Xmax-Xmin)*(rectxz.right-rectxz.left)+rectxz.left),
        int((y-Ymin)/(Ymax-Ymin)*(rectxz.bottom-rectxz.top)+rectxz.top));
			pDCyz->LineTo(
        int((x-Xmin)/(Xmax-Xmin)*(rectyz.right-rectyz.left)+rectyz.left),
        int((y-Ymin)/(Ymax-Ymin)*(rectyz.bottom-rectyz.top)+rectyz.top));
*/
  }
			fclose(fOut);
		m_TrackAbs2.Format(" t    %.1f",m_Time);
		m_RateAbs2.Format(" t    %.1f",m_Time);
		m_PhaseAbs2.Format(" X    %.1f",Xmax);
		m_TrackAbs.Format("%.1f",0);
		m_RateAbs.Format("%.1f",0);
		m_PhaseAbs.Format("%.1f",Xmin);
		m_OrdTrack.Format("%.1f",Xmax);
		m_OrdTrack2.Format("%.1f",Xmin);
		m_OrdRate.Format("%.1f",Ymax);
		m_OrdRate2.Format("%.1f",Ymin);
		m_OrdPhase.Format("%.1f",Ymax);
		UpdateData(false);
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CProgaDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CProgaDlg::OnButGraph() 
{
	// TODO: Add your control notification handler code here
	m_bGraph=true;
	UpdateData(true);
	Invalidate();
}

void CProgaDlg::OnButFile() 
{
	CFileDialog dlg(TRUE,"dat", m_szOutFileName, OFN_NOREADONLYRETURN|OFN_HIDEREADONLY,"DAT files (*.dat)|*.dat|All files (*.*)|*||");
	if (dlg.DoModal()==TRUE) m_szOutFileName = dlg.GetPathName();	
	UpdateData(false);
}

void CProgaDlg::OnButAbout() 
{
//	_spawnl(_P_NOWAIT , "iexplore", "   ", NULL );
}
